/*
	main.cpp
	Written by Hiep Dam
	From The Witches' Brew
	Dec 2 95
	
	App showing sample usage of of the class DataList template.
	
	Note: you will not see any output. Open the application with
	ResEdit to see the results.
*/

#include "InitToolbox.h"
#include "Class_DataList.cpp"

// Instantiate now
template class DataList<short, char>;		// A standard STR# format
template class DataList<short, short>;
template class DataList<short, unsigned long>;

void LongDataList();

void main() {
	InitToolbox();
	
	DataList<short, char> dList;
	Handle strList, newList;
	Str255 theStr;
	Str255 setStr = "\pThis is a sample string to set.";
	StringPtr strPtr;
	short i;
	
	strList = GetResource('STR#', 128);
	dList.SetData(strList);
	
	for (i = 1; i <= dList.GetNumberOfEntries(); i++) {
		strPtr = (StringPtr)dList.GetNextEntry();
		BlockMove(&strPtr[0], &theStr[0], strPtr[0]+1);
	}
	
	// Various ways to work with the DataList
	dList.InsertEntry((EntryPtr)&setStr, dList.GetNumberOfEntries());
	dList.InsertEntry((EntryPtr)&setStr, 1);
	dList.AppendEntry((EntryPtr)&setStr);
	dList.AppendEntry((EntryPtr)&setStr[1], setStr[0]);
	dList.DeleteEntry(dList.GetNumberOfEntries());
	dList.DeleteEntry(1);
	
	newList = dList.GetData();
	SetHandleSize(strList, GetHandleSize(newList));
	BlockMove(*newList, *strList, GetHandleSize(newList));
	ChangedResource(strList);
	WriteResource(strList);
	
	LongDataList();
}

// A really long string structure. Easier to use than c-strings
// (no parsing for the end zero byte) and supports longer
// strings than p-strings.
typedef struct {
	unsigned long len;
	char str[1];
} longStr;

void LongDataList() {
	DataList<short, unsigned long> dList;
	EntryPtr anEntry;
	long len;
	char *str;
	Str255 str1 = "\pThis is string 1",
		str2 = "\pThis is string 2",
		str3 = "\pThis is string 3";
	
	dList.AppendEntry((EntryPtr)&str1[1], str1[0]);
	dList.AppendEntry((EntryPtr)&str3[1], str3[0]);
	dList.InsertEntry((EntryPtr)&str2[1], str2[0], 2);
	
	anEntry = dList.GetEntry(1);
	len = ((longStr*)anEntry)->len;
	str = ((longStr*)anEntry)->str;
	
	Handle list = dList.GetData();
	AddResource(list, 'STRL', 129, "\pList data");
	WriteResource(list);
	ReleaseResource(list);
}
