#pragma once
// ===========================================================================
//	CQCamPane.h						A pane using the newly created CQuickCam obj
// ===========================================================================
//
//	12/2/95		Finsihed CQuickCam enought to try this out.

#include	<LPane.h>
#include	<LPeriodical.h>
#include	<QuickTimeComponents.h>
#include	"CQuickCam.h"

class	CGrabPane : public LPane, public LPeriodical, public CQuickCam {
public:
	enum { class_ID = 'grab' };
	static CGrabPane*	CreateGrabPaneStream(LStream *inStream);

					CGrabPane( void );
					CGrabPane(LStream *inStream);
	virtual			~CGrabPane( void );
	
	virtual void	DrawSelf();	
	
	
	virtual	void	SpendTime(const EventRecord &inMacEvent);
	virtual void	EventMouseUp(const EventRecord &inMacEvent);
	virtual	void	ClickSelf(const SMouseDownEvent &inMouseDown);

	// Custom methods...
	void			RunCompressionDialog( void );
	void			RunGrabberDialog( void );


protected:

	virtual void	FinishCreateSelf();
	
	virtual void	ShowSelf();
	virtual void	HideSelf();
	virtual void	ActivateSelf();
	virtual void	DeactivateSelf();
	virtual void	EnableSelf();
	virtual void	DisableSelf();

	void			UpdateBuffer( void );
	void			DrawBuffer( void );
private:
	void			AdjustRectangles( void );
	void			AutoContrast( Rect& r );

	VideoDigitizerComponent	vdig;			// Instance of a vdig
	DigitizerInfo			vdigInfo;		// Information
	GWorldPtr				gWorld;			// Offscreen world for capture
	Rect					videoFrame;
	
	PicHandle				grabPict;		// Handle to captured picture
	Rect					oldGlobalFrame;

};

