/*
	File:		SimpleParseUtils.cp
	
	Contains:	Utilities for useful for very simple
				parsing tasks.
	
	Version:	1.0 (for System 7.x)
	
	Copyright:	1995 Chris K. Thomas.  All Rights Reserved.
*/

// * if inMem points to a the same string as inString, true
Boolean StrEquals(const unsigned char *inString, char *inMem);

// * if inMem points to a the same string as inString followed by whitespace, true
Boolean StrEqualsToken(const unsigned char *inString, char *inMem);

// * if inMem points to a the same string as inString followed by whitespace, true
Boolean PtrEqualsToken(const Ptr inString, char *inMem);

// * if inMem points to a char which is in inString, true
Boolean StrEqualsChars(const unsigned char *inString, char *inMem);

// * count whitespace chars
long CountWhiteSpace(char *inMem, long inLength);

// * return a pascal string containing the next token
StringPtr GetTokenString(char *inMem, long inLength);

// * return a length-unlimited string containing the next token
Ptr GetTokenPtr(char *inMem, long inLength);

// * return a token with a custom delimiting string
Ptr GetDelimitedToken(const unsigned char *inDelimiter, char *inMem, long inLength);

// * return the char in inString actually found
short FindSelectChar(const unsigned char *inString, char *inMem, long inLength);

// * get all text from inMem to end of line
Ptr	GetEntireLine(char *inMem, long inLength);

